[CCode (cprefix = "E", lower_case_cprefix = "e_")]
namespace E {
	[CCode (cheader_filename = "libedata-cal/libedata-cal.h", type_id = "e_cal_backend_get_type ()")]
	public class CalBackend : E.Backend, E.TimezoneCache {
		[CCode (has_construct_function = false)]
		private CalBackend ();
		public iCal.ComponentKind get_kind ();
		public E.DataCal ref_data_cal ();
		public void set_data_cal (E.DataCal data_cal);
		public E.SourceRegistry get_registry ();
		public bool get_writable ();
		public void set_writable (bool writable);
		public bool is_opened ();
		public bool is_readonly ();
		public unowned string get_cache_dir ();
		public string dup_cache_dir ();
		public void set_cache_dir (string cache_dir);
		public string create_cache_filename (string uid, string filename, int fileindex);
		public void add_view (E.DataCalView view);
		public void remove_view (E.DataCalView view);
		public GLib.List<E.DataCalView> list_views ();
		public virtual string get_backend_property (string prop_name);
		public bool open_sync (GLib.Cancellable? cancellable = null) throws GLib.Error;
		public async bool open (GLib.Cancellable? cancellable = null) throws GLib.Error;
		public bool refresh_sync (GLib.Cancellable? cancellable = null) throws GLib.Error;
		public async bool refresh (GLib.Cancellable? cancellable = null) throws GLib.Error;
		public string get_object_sync (string uid, string rid, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public async string get_object (string uid, string rid, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public bool get_object_list_sync (string query, GLib.Queue<string> out_objects, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public async bool get_object_list (string query, GLib.Queue<string> out_objects, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public bool get_free_busy_sync (time_t start, time_t end, string[] users, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public async bool get_free_busy (time_t start, time_t end, string[] users, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public bool create_objects_sync (string[] calobjs, GLib.Queue<string> out_uids, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public async bool create_objects (string[] calobjs, GLib.Queue<string> out_uids, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public bool modify_objects_sync (string[] calobjs, E.CalObjModType mod, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public async bool modify_objects (string[] calobjs, E.CalObjModType mod, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public bool remove_objects_sync (GLib.List<E.CalComponentId?> component_ids, E.CalObjModType mod, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public async bool remove_objects (GLib.List<E.CalComponentId?> component_ids, E.CalObjModType mod, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public bool receive_objects_sync (string calobj, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public async bool receive_objects (string calobj, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public string send_objects_sync (string calobj, GLib.Queue<string> out_users, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public async string send_objects (string calobj, GLib.Queue<string> out_users, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public bool get_attachment_uris_sync (string uid, string rid, GLib.Queue<string> out_attachment_uris, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public async bool get_attachment_uris (string uid, string rid, GLib.Queue<string> out_attachment_uris, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public bool discard_alarm_sync (string uid, string rid, string alarm_uid, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public async bool discard_alarm (string uid, string rid, string alarm_uid, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public string get_timezone_sync (string tzid, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public async string get_timezone (string tzid, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public bool add_timezone_sync (string tzobject, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public async bool add_timezone (string tzobject, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public virtual void start_view (E.DataCalView view);
		public void stop_view (E.DataCalView view);
		public void notify_component_created (E.CalComponent component);
		public void notify_component_modified (E.CalComponent old_component, E.CalComponent new_component);
		public void notify_component_removed (E.CalComponentId id, E.CalComponent old_component, E.CalComponent new_component);
		public void notify_error (string message);
		public void notify_property_changed (string prop_name, string prop_value);
		public void empty_cache (E.CalBackendCache cache);
		[NoAccessorMethod]
		public string cache_dir { get; set; }
		[NoAccessorMethod]
		public ulong kind { get; construct set; }
		[NoAccessorMethod]
		public E.SourceRegistry registry { get; construct set; }
		[NoAccessorMethod]
		public bool writable { get; set; }
		public virtual signal void shutdown (string sender);
		public signal void closed ();
	}
	[CCode (cheader_filename = "libedata-cal/libedata-cal.h", type_id = "e_cal_backend_cache_get_type ()")]
	public class CalBackendCache : E.FileCache {
		[CCode (has_construct_function = false)]
		public CalBackendCache (string filename);
		public E.CalComponent get_component (string uid, string rid);
		public bool put_component (E.CalComponent comp);
		public bool remove_component (string uid, string rid);
		public GLib.List<E.CalComponent> get_components ();
		public GLib.SList<E.CalComponent> get_components_by_uid (string uid);
		public unowned iCal.TimeZone get_timezone (string tzid);
		public bool put_timezone (iCal.TimeZone zone);
		public bool put_default_timezone (iCal.TimeZone default_zone);
		public iCal.TimeZone get_default_timezone ();
		public GLib.SList<string> get_keys ();
		public string get_marker ();
		public void set_marker ();
		public bool put_server_utc_time (string utc_str);
		public string get_server_utc_time ();
		public bool put_key_value (string key, string value);
		public string get_key_value (string key);
		public bool remove (string dirname, string basename);
	}
	[CCode (cheader_filename = "libedata-cal/libedata-cal.h", type_id = "e_cal_backend_factory_get_type ()")]
	public abstract class CalBackendFactory : E.BackendFactory {
		[CCode (has_construct_function = false)]
		private CalBackendFactory ();
		public class string factory_name;
		public class iCal.ComponentKind component_kind;
		public class GLib.Type backend_type;
	}
	namespace CalBackendProperty {
		[CCode (cheader_filename = "libedata-cal/libedata-cal.h", cname = "CAL_BACKEND_PROPERTY_CAL_EMAIL_ADDRESS")]
		public const string CAL_EMAIL_ADDRESS;
		[CCode (cheader_filename = "libedata-cal/libedata-cal.h", cname = "CAL_BACKEND_PROPERTY_ALARM_EMAIL_ADDRESS")]
		public const string ALARM_EMAIL_ADDRESS;
		[CCode (cheader_filename = "libedata-cal/libedata-cal.h", cname = "CAL_BACKEND_PROPERTY_DEFAULT_OBJECT")]
		public const string DEFAULT_OBJECT;
		[CCode (cheader_filename = "libedata-cal/libedata-cal.h", cname = "CAL_BACKEND_PROPERTY_REVISION")]
		public const string REVISION;
		[CCode (cheader_filename = "libedata-cal/libedata-cal.h", cname = "CLIENT_BACKEND_PROPERTY_CAPABILITIES")]
		public const string CAPABILITIES;
	}
	[CCode (cheader_filename = "libedata-cal/libedata-cal.h", type_id = "e_cal_backend_store_get_type ()")]
	public class CalBackendStore : GLib.Object {
		[CCode (has_construct_function = false)]
		public CalBackendStore (string path, E.TimezoneCache cache);
		public string get_path ();
		public E.TimezoneCache ref_timezone_cache ();
		public bool load ();
		public bool is_loaded ();
		public bool clean ();
		public unowned E.CalComponent get_component (string uid, string rid);
		public bool put_component_with_time_range (E.CalComponent comp, time_t occurence_start, time_t occurence_end);
		public bool put_component (E.CalComponent comp);
		public bool remove_component (string uid, string rid);
		public bool has_component (string uid, string rid);
		public iCal.TimeZone get_default_timezone ();
		public bool set_default_timezone (iCal.TimeZone zone);
		public GLib.SList<E.CalComponent> get_components_by_uid (string uid);
		public string get_components_by_uid_as_ical_string (string uid);
		public GLib.SList<E.CalComponent> get_components ();
		public GLib.SList<E.CalComponent> get_components_occuring_in_range (time_t start, time_t end);
		public GLib.SList<E.CalComponentId?> get_component_ids ();
		public string get_key_value (string key);
		public bool put_key_value (string key, string value);
		public void thaw_changes ();
		public void freeze_changes ();
		public void interval_tree_add_comp (E.CalComponent comp, time_t start, time_t end);
		[NoAccessorMethod]
		public string path { get; construct set; }
		[NoAccessorMethod]
		public E.TimezoneCache timezone_cache { get; construct set; }
	}
	[CCode (cheader_filename = "libedata-cal/libedata-cal.h", type_id = "e_cal_backend_sexp_get_type ()")]
	public class CalBackendSExp : E.CalBackend {
		[CCode (has_construct_function = false)]
		public CalBackendSExp (string text);
		public unowned string text ();
		public bool match_object (string object, E.TimezoneCache cache);
		public bool match_comp (E.CalComponent comp, E.TimezoneCache cache);
		public E.SExpResult func_time_now (E.SExp esexp, int argc, ref E.SExpResult argv, void* data);
		public E.SExpResult func_make_time   (E.SExp esexp, int argc, ref E.SExpResult argv, void* data);
		public E.SExpResult func_time_add_day (E.SExp esexp, int argc, ref E.SExpResult argv, void* data);
		public E.SExpResult func_time_day_begin (E.SExp esexp, int argc, ref E.SExpResult argv, void* data);
		public E.SExpResult func_time_day_end (E.SExp esexp, int argc, ref E.SExpResult argv, void* data);
		public bool evaluate_occur_times (ref time_t start, ref time_t end);
	}
	[CCode (cheader_filename = "libedata-cal/libedata-cal.h", type_id = "e_cal_backend_sync_get_type ()")]
	public class CalBackendSync : E.CalBackend {
		[CCode (has_construct_function = false)]
		private CalBackendSync ();
		public void open (E.DataCal cal, GLib.Cancellable? cancellable, bool only_if_exists) throws GLib.Error;
		public virtual void open_sync (E.DataCal cal, GLib.Cancellable? cancellable, bool only_if_exists) throws GLib.Error;
		public void refresh (E.DataCal cal, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public virtual void refresh_sync (E.DataCal cal, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public void get_object (E.DataCal cal, GLib.Cancellable? cancellable, string uid, string rid, ref string calobj) throws GLib.Error;
		public virtual void get_object_sync (E.DataCal cal, GLib.Cancellable? cancellable, string uid, string rid, ref string calobj) throws GLib.Error;
		public void get_object_list (E.DataCal cal, GLib.Cancellable? cancellable, string sexp, GLib.SList<string> calobjs) throws GLib.Error;
		public virtual void get_object_list_sync (E.DataCal cal, GLib.Cancellable? cancellable, string sexp, GLib.SList<string> calobjs) throws GLib.Error;
		public void get_free_busy (E.DataCal cal, GLib.Cancellable? cancellable, GLib.SList<string> users, time_t start, time_t end, GLib.SList<string> freebusyobjects) throws GLib.Error;
		public virtual void get_free_busy_sync (E.DataCal cal, GLib.Cancellable? cancellable, GLib.SList<string> users, time_t start, time_t end, GLib.SList<string> freebusyobjects) throws GLib.Error;
		public void create_objects (E.DataCal cal, GLib.Cancellable? cancellable, GLib.SList<string> calobjs, GLib.SList<string> uids, GLib.SList<E.CalComponent> new_components) throws GLib.Error;
		public virtual void create_objects_sync (E.DataCal cal, GLib.Cancellable? cancellable, GLib.SList<string> calobjs, GLib.SList<string> uids, GLib.SList<E.CalComponent> new_components) throws GLib.Error;
		public void modify_objects (E.DataCal cal, GLib.Cancellable? cancellable, GLib.SList<string> calobjs, E.CalObjModType mod, GLib.SList<E.CalComponent> old_components, GLib.SList<E.CalComponent> new_components) throws GLib.Error;
		public virtual void modify_objects_sync (E.DataCal cal, GLib.Cancellable? cancellable, GLib.SList<string> calobjs, E.CalObjModType mod, GLib.SList<E.CalComponent> old_components, GLib.SList<E.CalComponent> new_components) throws GLib.Error;
		public void remove_objects (E.DataCal cal, GLib.Cancellable? cancellable, GLib.SList<E.CalComponentId?> ids, E.CalObjModType mod, GLib.SList<E.CalComponent> old_components, GLib.SList<E.CalComponent> new_components) throws GLib.Error;
		public virtual void remove_objects_sync (E.DataCal cal, GLib.Cancellable? cancellable, GLib.SList<unowned E.CalComponentId?> ids, E.CalObjModType mod, GLib.SList<E.CalComponent> old_components, GLib.SList<E.CalComponent> new_components) throws GLib.Error;
		public void receive_objects (E.DataCal cal, GLib.Cancellable? cancellable, string calobj) throws GLib.Error;
		public virtual void receive_objects_sync (E.DataCal cal, GLib.Cancellable? cancellable, string calobj) throws GLib.Error;
		public void send_objects (E.DataCal cal, GLib.Cancellable? cancellable, string calobj, GLib.SList<string> users, ref string modified_calobj) throws GLib.Error;
		public virtual void send_objects_sync (E.DataCal cal, GLib.Cancellable? cancellable, string calobj, GLib.SList<string> users, ref string modified_calobj) throws GLib.Error;
		public void get_attachment_uris (E.DataCal cal, GLib.Cancellable? cancellable, string uid, string rid, GLib.SList<string> attachments) throws GLib.Error;
		public virtual void get_attachment_uris_sync (E.DataCal cal, GLib.Cancellable? cancellable, string uid, string rid, GLib.SList<string> attachments) throws GLib.Error;
		public void discard_alarm (E.DataCal cal, GLib.Cancellable? cancellable, string uid, string rid, string auid) throws GLib.Error;
		public virtual void discard_alarm_sync (E.DataCal cal, GLib.Cancellable? cancellable, string uid, string rid, string auid) throws GLib.Error;
		public void get_timezone (E.DataCal cal, GLib.Cancellable? cancellable, string tzid, ref string tzobject) throws GLib.Error;
		public virtual void get_timezone_sync (E.DataCal cal, GLib.Cancellable? cancellable, string tzid, ref string tzobject) throws GLib.Error;
		public void add_timezone (E.DataCal cal, GLib.Cancellable? cancellable, string tzobject) throws GLib.Error;
		public virtual void add_timezone_sync (E.DataCal cal, GLib.Cancellable? cancellable, string tzobject) throws GLib.Error;
	}
	[CCode (cheader_filename = "libedata-cal/libedata-cal.h", type_id = "e_data_cal_get_type ()")]
	public class DataCal : GLib.Object, GLib.Initable {
		[CCode (has_construct_function = false)]
		public DataCal (E.CalBackend backend, GLib.DBusConnection connection, string object_path) throws GLib.Error;
		public GLib.Error create_error (E.DataCal.CallStatus status, string custom_msg);
		public GLib.Error create_error_fmt (E.DataCal.CallStatus status, string custom_msg_fmt, ...);
		public string status_to_string (E.DataCal.CallStatus status);
		public E.CalBackend ref_backend ();
		public GLib.DBusConnection get_connection ();
		public string get_object_path ();
		public void respond_open (uint32 opid, GLib.Error error);
		public void respond_refresh (uint32 opid, GLib.Error error);
		public void respond_get_object (uint32 opid, GLib.Error error, string object);
		public void respond_get_object_list (uint32 opid, GLib.Error error, GLib.SList<string> objects);
		public void respond_get_free_busy (uint32 opid, GLib.Error error);
		public void respond_create_objects (uint32 opid, GLib.Error error, GLib.SList<string> uids, GLib.SList<E.CalComponent> new_components);
		public void respond_modify_objects (uint32 opid, GLib.Error error, GLib.SList<E.CalComponent> old_components, GLib.SList<E.CalComponent> new_components);
		public void respond_remove_objects (uint32 opid, GLib.Error error, GLib.SList<E.CalComponentId?> ids, GLib.SList<E.CalComponent> old_components, GLib.SList<E.CalComponent> new_components);
		public void respond_receive_objects (uint32 opid, GLib.Error error);
		public void respond_send_objects (uint32 opid, GLib.Error error, GLib.SList<string> users, string calobj);
		public void respond_get_attachment_uris (uint32 opid, GLib.Error error, GLib.SList<string> attachment_uris);
		public void respond_discard_alarm (uint32 opid, GLib.Error error);
		public void respond_get_timezone (uint32 opid, GLib.Error error, string tzobject);
		public void respond_add_timezone (uint32 opid, GLib.Error error);
		public void report_error (string message);
		public void report_free_busy_data (GLib.SList<string> freebusy);
		public void report_backend_property_changed (string prop_name, string prop_value);
		public enum CallStatus {
			Success,
			Busy,
			RepositoryOffline,
			PermissionDenied,
			InvalidRange,
			ObjectNotFound,
			InvalidObject,
			ObjectIdAlreadyExists,
			AuthenticationFailed,
			AuthenticationRequired,
			UnsupportedField,
			UnsupportedMethod,
			UnsupportedAuthenticationMethod,
			TLSNotAvailable,
			NoSuchCal,
			UnknownUser,
			OfflineUnavailable,

			/* These can be returned for successful searches, but
				indicate the result set was truncated */
			SearchSizeLimitExceeded,
			SearchTimeLimitExceeded,

			InvalidQuery,
			QueryRefused,

			CouldNotCancel,

			OtherError,
			InvalidServerVersion,
			InvalidArg,
			NotSupported,
			NotOpened
		}
	}
	[CCode (cheader_filename = "libedata-cal/libedata-cal.h", type_id = "e_data_cal_factory_get_type ()")]
	public abstract class DataCalFactory : E.DataFactory, E.Extensible, GLib.Initable {
		[CCode (has_construct_function = false)]
		public DataCalFactory (GLib.Cancellable? cancellable = null) throws GLib.Error;
		E.SourceRegistry get_registry ();
	}
	[CCode (cheader_filename = "libedata-cal/libedata-cal.h", type_id = "e_data_cal_view_get_type ()")]
	public class DataCalView : GLib.Object {
		[CCode (has_construct_function = false)]
		public DataCalView (E.CalBackend backend, E.CalBackendSExp sexp, GLib.DBusConnection connection, string object_path) throws GLib.Error;
		public E.CalBackend get_backend ();
		public GLib.DBusConnection get_connection ();
		public string get_object_path ();
		public unowned E.CalBackendSExp get_sexp ();
		public bool object_matches (string object);
		public bool component_matches (E.CalComponent component);
		public bool is_started ();
		public bool is_completed ();
		public bool is_stopped ();
		public GLib.HashTable<string, unowned string> get_fields_of_interest ();
		public E.CalClientViewFlags get_flags ();
		public string get_component_string (E.CalComponent component);
		public void notify_components_added (GLib.SList<E.CalComponent> ecalcomponents);
		public void notify_components_added_1 (E.CalComponent component);
		public void notify_components_modified (GLib.SList<E.CalComponent> ecalcomponents);
		public void notify_components_modified_1 (E.CalComponent component);
		public void notify_objects_removed (GLib.SList<E.CalComponentId?> ids);
		public void notify_objects_removed_1 (E.CalComponentId id);
		public void notify_progress (int percent, string message);
		public void notify_complete (GLib.Error? error);
	}
	[CCode (cheader_filename = "libedata-cal/libedata-cal.h", type_id = "e_intervaltree_get_type ()")]
	public class IntervalTree : GLib.Object {
		[CCode (has_construct_function = false)]
		public IntervalTree ();
		public bool insert (time_t start, time_t end, E.CalComponent comp);
		public bool remove (string uid, string rid);
		public GLib.List<E.CalComponent> search (time_t start, time_t end);
		public void destroy ();
	}
	[CCode (cheader_filename = "libedata-cal/libedata-cal.h", cname = "EDS_CALENDAR_MODULES")]
	public const string EDS_CALENDAR_MODULES;
}